unit Unit1;

{$mode objfpc}{$H+}

interface

uses
    SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, FileCtrl, FileUtil, Buttons, Menus, ExtCtrls, ComCtrls,
    MacOSAll, CFPreferences;

type

  { TForm1 }

  TForm1 = class(TForm)
    BtnMake: TButton;
    BtnAbout: TButton;
    BtnSelectSDcard: TButton;
    FlbGameFiles: TFileListBox;
    LblGamesFolder: TLabel;
    MainMenu1: TMainMenu;
    ProgressBar: TProgressBar;
    RBoriginal: TRadioButton;
    RB2019: TRadioButton;
    TxtGamesFolder: TEdit;
    TxtSDCard: TEdit;
    LblSelectSD: TLabel;
    LblStatus: TLabel;
    procedure BtnAboutClick(Sender: TObject);
    procedure BtnMakeClick(Sender: TObject);
    procedure BtnSelectSDcardClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure DeleteFiles(Files:TFileListBox);
    procedure CreateMenuFiles();
    procedure CreateTitlesRtf();
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  IsValid: boolean = false;
  Pref: integer;
begin

  Pref := CFPreferencesGetAppIntegerValue(CFStr('VecMultiVersion'),kCFPreferencesCurrentApplication,IsValid);
  if IsValid then
  begin
    if (Pref = 1) then
      RB2019.Checked := true
    else
      RBoriginal.Checked := true;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var
  ItemName: CFStringRef;
  ItemVal: CFPropertyListRef;
begin
  if (RB2019.Checked) then
    begin
      ItemName := CFStr('VecMultiVersion');
      ItemVal := CFStringCreateWithPascalString(kCFAllocatorDefault,'1',kCFStringEncodingUTF8);
      CFPreferencesSetAppValue(ItemName,ItemVal,kCFPreferencesCurrentApplication);
    end
  else
    begin
      ItemName := CFStr('VecMultiVersion');
      ItemVal := CFStringCreateWithPascalString(kCFAllocatorDefault,'0',kCFStringEncodingUTF8);
      CFPreferencesSetAppValue(ItemName,ItemVal,kCFPreferencesCurrentApplication);
    end;
end;

procedure TForm1.BtnAboutClick(Sender: TObject);
begin
  ShowMessage('MenuMaker v0.4' + LineEnding + LineEnding +
              'Menu compiler for VecMulti' + LineEnding + LineEnding +
              '© Richard Hutchinson 2011' + LineEnding + LineEnding +
              'Mac Port by Darrell Spice, Jr.' + LineEnding + LineEnding +
              'Mac Icon by Nathan Strum');
end;


function Spaces(Len:integer):String;
var
  i: integer;
  s: string;
  begin
    s := '';
    for i := 1 to Len do
    s := s + ' ';
    Spaces := s;
end;

procedure AddToEOF(FPN,Str:string);
var gs:TFileStream;
  begin
    gs := TFileStream.Create(FPN,fmOpenWrite);
    gs.Seek(0,soFromEnd);
    gs.Write(Str[1],Length(Str));
    gs.Free;
end;

procedure SortFiles(Files:TFileListBox);
// for some reason TFileListBox.Sorted := true does not work
// so call this to sort the filenames.
var
   i: integer;
   j: integer;
   swap: string;
begin
  for i := 0 to Files.Count - 2 do
    for j := i + 1 to Files.Count - 1 do
    begin
      if Files.Items[i] > Files.Items[j] then
      begin
        swap            := Files.Items[i];
        Files.Items[i]  := Files.Items[j];
        Files.Items[j]  := swap;
      end;
    end;
end;

procedure TForm1.DeleteFiles(Files:TFileListBox);
var
   index: integer;
begin
  for index := 0 to Files.Count -1 do
  begin
    ProgressBar.Position := ProgressBar.Position + 1;
    Application.ProcessMessages;
    DeleteFile(TxtSDCard.Caption + DirectorySeparator + Files.Items[index]);
  end;
end;

procedure TForm1.CreateMenuFiles();
var
  char_1: integer;
  char_2: integer;
  file_from: string;
  file_to: string;
  index: integer;
  pad: string;

begin
  char_1 := 65;   // A
  char_2 := 65;   // A

  for index := 0 to FlbGameFiles.Count -1 do
  begin
    ProgressBar.Position := ProgressBar.Position + 1;
    Application.ProcessMessages;
    file_from := TxtGamesFolder.Text + DirectorySeparator + FlbGameFiles.Items[index];
    if char_2 = 91 then begin // if char_2 > 'Z'
      char_2 := 65;
      char_1 := char_1 + 1;
    end;
    pad := chr(char_1) + chr(char_2);
    file_to := TxtSDCard.Text + DirectorySeparator + pad + '.men';
    CopyFile(PChar(file_from),PChar(file_to),false); // why PChar ?
    char_2 := char_2 + 1 ;
  end;
end;

procedure TForm1.CreateTitlesRtf();
var
   pack: string;
   temp: string;
   index: integer;
   gs: TFileStream;
   MenuFile: array[1..512] of string;
   gamenum_lo: string;
   gamenum_hi: string;
   titlesfile: string;

begin
  ProgressBar.Position := ProgressBar.Position + 1;
  Application.ProcessMessages;
  pack := '';
  for index := 0 to FlbGameFiles.Count - 1 do
  begin
    temp := Copy(FlbGameFiles.Items[index],1,Length(FlbGameFiles.Items[index])-4);
    MenuFile[index+1] := temp+Spaces(13-(Length(temp)));
    SetLength(MenuFile[index+1],13);
    if RB2019.Checked then
       pack := pack + MenuFile[index+1]
    else
      pack := pack + chr(124)+MenuFile[index+1]+chr(124)+chr(13);
  end;

  gamenum_hi := chr(hi(FlbGameFiles.Count));
  gamenum_lo := chr(lo(FlbGameFiles.Count));

  titlesfile := TxtSDCard.Text + DirectorySeparator + 'Titles.rtf';
  gs := TFileStream.Create(titlesfile, fmCreate);
  gs.Free;

  if RB2019.Checked then
    AddToEOF(titlesfile, gamenum_hi + gamenum_lo + pack)
  else
    AddToEOF(titlesfile, gamenum_hi + gamenum_lo + chr(13) + pack);
end;


procedure TForm1.BtnMakeClick(Sender: TObject);
var
   OldMenuFiles: TFileListBox;

begin
  LblStatus.Caption := 'WORKING...';
  BtnMake.Enabled := false;
  BtnAbout.Enabled := false;

  OldMenuFiles := TFileListBox.Create(nil);
  OldMenuFiles.Mask := '*.men';
  OldMenuFiles.Directory := TxtSDCard.Caption;

  // Files to delete + Files to copy + Titles.rtf
  ProgressBar.Max := OldMenuFiles.Count + FlbGameFiles.Count + 1;
  ProgressBar.Position := 0;
  ProgressBar.Visible := true;

  DeleteFiles(OldMenuFiles);
  CreateMenuFiles;
  CreateTitlesRtf;

  LblStatus.Caption := 'FINISHED';
  BtnAbout.Enabled := true;
  ProgressBar.Visible := false;
end;


procedure TForm1.BtnSelectSDcardClick(Sender: TObject);
var
   sdd : TSelectDirectoryDialog;
begin
  sdd := TSelectDirectoryDialog.Create(nil);
  sdd.InitialDir := DirectorySeparator + 'Volumes';
  if sdd.Execute then
  begin
    TxtSDCard.Text := sdd.FileName;
    TxtGamesFolder.Text := TxtSDCard.Text + DirectorySeparator + 'Games';
  end;
  sdd.Free;

  if DirectoryExists(TxtGamesFolder.Text) then
  begin
    FlbGameFiles.Mask := '*.bin';
    FlbGameFiles.Directory := TxtGamesFolder.Text;
    FlbGameFiles.UpdateFileList;     // need this if Directory is ever changed
    LblStatus.Caption := FlbGameFiles.Count.ToString() + ' games found';
    if FlbGameFiles.Count > 0 then SortFiles(FlbGameFiles);
    if FlbGameFiles.Count > 0 then
    BtnMake.Enabled := FlbGameFiles.Count > 0;
    if (BtnMake.Enabled) then BtnMake.SetFocus;
  end
  else
  begin
    FlbGameFiles.Clear;
    BtnMake.Enabled := false;
    LblStatus.Caption := 'Games directory does not exist';
  end;
end;


end.

